#!/usr/bin/perl
# modact.cgi
# Modify Action for Tarantella Services Monitor

require './tarantella-lib.pl';
if ( ! $access{'monitor'} )   { &redirect("index.cgi"); }
if ( $config{'has_monitor'} ne "true" )  { &redirect("index.cgi"); }
&ReadParse();
if ( !$in{aliasAct} ) { &redirect("mon_actdef.cgi"); }
if ( !$in{monTarget} ) { &redirect("mon_actdef.cgi"); }
if ( !$in{monCondition} ) { &redirect("mon_actdef.cgi"); }
if ( !$in{monAction} ) { &redirect("mon_actdef.cgi"); }
&header($text{'index_monitor_act'}, "", "monitor_act" );
$aliasAct=$in{aliasAct};
$monTarget=$in{monTarget};
$monCondition=$in{monCondition};
$monAction=$in{monAction};
$monConditionValue=$in{monConditionValue};
$monScript=$in{monScript};
$monHow=$in{monHow};
$descrip=$in{descrip};
$monWhen=$in{monWhen};
print "<table width=100% border>\n";
print "<tr $tb> <td><i>$text{'titidx_monitor_modact'}:</i><b> $aliasAct - $descrip </b></td> </tr>\n";
print "<tr $cb> <td><table width=100%>\n";
if ( $monHow eq "task" ) { 
    foreach $arr ("mins", "hours", "days", "months", "weekdays") {
	if ($in{"all_$arr"}) {
		# All mins/hrs/etc.. chosen
		$job->{$arr} = "*";
	}
	elsif (defined($in{$arr})) {
		# Need to work out and simplify ranges selected
		undef(@range);
		undef(@newrange);
		@range = split(/\0/, $in{$arr});
		@range = sort { $a <=> $b } @range;
		$start = -1;
		for($i=0; $i<@range; $i++) {
			if ($i && $range[$i]-1 == $range[$i-1]) {
				# ok.. looks like a range
				if ($start < 0) { $start = $i-1; }
			}
			elsif ($start < 0) {
				# Not in a range at all
				push(@newrange, $range[$i]);
			}
			else {
				# End of the range.. add it
				$newrange[@newrange - 1] =
					"$range[$start]-".$range[$i-1];
				push(@newrange, $range[$i]);
				$start = -1;
			}
		}
		if ($start >= 0) {
			# Reached the end while in a range
			$newrange[@newrange - 1] =
				"$range[$start]-".$range[$i-1];
		}
		$job->{$arr} = join(',' , @newrange);
	}
	else {
                print "<tr><p><b>ERROR: ".eval("\$text{'edit_$arr'}")."</b></tr>\n";
                &footHere;
                exit;
	}
    }
 }
 if ( $monTarget eq "user" ) {
    $objectAct=$in{'username'};
 } elsif  ( $monTarget eq "ou" ) {
     $objectAct=$in{'user_ou'};
 } elsif  ( $monTarget eq "host" ) {
     $objectAct=$in{'hostname'};
 } elsif  ( $monTarget eq "grphosts" ) {
     $objectAct=$in{'usergrphosts'};
 } elsif  ( $monTarget eq "app" ) {
     $objectAct=$in{'appname'};
 } elsif  ( $monTarget eq "grpapps" ) {
     $objectAct=$in{'grpappsname'};
 }
 if ( $monScript eq "none" ) { $monScript="-" };
 if ( $aliasAct ne "" ) {
    $lin_act=$aliasAct."::".$descrip."::".$monTarget."::".$objectAct."::".$monCondition."::".$monConditionValue."::".$monAction."::".$monScript."::";
    if ( $monHow eq "task" ) { 
           foreach $arr ("mins", "hours", "days", "months", "weekdays") {
                 $lin_act=$lin_act.$job->{$arr}." ";
           }
    } else {
       $lin_act=$lin_act.$monWhen;
    }
    $lin_act=$lin_act."::".$monHow."::";
    @listactions=&list_actions();
    @list__actions = sort {$a->{'name'} cmp $b->{'name'}} @listactions;
    &lock_file($config{'act_list'});    
    open(FILEACT, ">$config{'act_list'}");
       foreach $action (@list__actions) {
               if ( $action->{'alias'} ne $aliasAct) {
                    $linact= $action->{'alias'}."::".$action->{'name'}."::".$action->{'target'}."::".$action->{'object'}."::".$action->{'condition'}."::".$action->{'conditionValue'}."::".$action->{'action'}."::".$action->{'script'}."::".$action->{'when'}."::".$action->{'how'}."::";
                    print FILEACT "$linact\n";
               }
       }
       print FILEACT "$lin_act\n";
    close (FILEACT);
    $str=$text{'user_update'}.$aliasAct." ->  ".$objectAct;
    &additional_log('modact.cgi', undef, $str);
    &webmin_log($config{'act_list'}, undef, "modify");
    &unlock_file($config{'act_list'});
    print "<tr><p><b>".$text{'user_update'}.$aliasAct." ->  ".$objectAct."</b></tr>\n";
    print "<tr></tr>\n";
 }
 &footHere;
 exit;
