#!/usr/bin/perl
# addusr.cgi
# ...  Servicios de Tarantella.

 require './tarantella-lib.pl';
do "ldap-lib.pl";

&header($text{'index_addusr'}, "", "");
print "<hr><p>\n"; 
&foreign_require("proc", "proc-lib.pl");
$ldap_server=1;
&connect ();
&ReadParse();

 $type_cmd = $in{ttacmd};
 print "<p>\n";
 print "<table width=100% border>\n";
 print "<tr $tb> <td><b>$text{'titidx_adusr'}</b></td> </tr>\n";
 print "<tr $cb> <td><table width=100%>\n";
 print "<center>\n";

 $username=$in{username};
 $administrador=false;
 $passwcache=true;
# $ntdomain=$config{'companyntdomain'};
 $ntdomain="";

if ($username)  {
    $userou=$in{userou};
    $password=$in{password};
    $organizationname="";
    $dn_ou="";
    $ens_ou="";
    foreach $ou (&list_ous()) {
         if ( $ou->{'alias'} eq $userou ) {
            $dn_ou=$ou->{obj};
            $ens_ou=$ou->{ens};
            $organizationname=$ou->{name};
            break;
         }
    }
    $dn = "cn=$username,$dn_ou,".$config{ldap_base};
    $surname=$username;
    $where="";
    $email="";
    if ( &add_usr() eq 0 ) {
        
        if ( $config{ldap2_server}.length gt 0 ) {
             $ldap_server=2;
             &connect ();
             if ( &add_usr() ne 0 ) { &err_replication() }
        }
        $lin_user="add::".$username."::".$password."::".$username."::".$dn;
        open(FILELDAPLOG, ">>$config{'ldap_log'}");
        print FILELDAPLOG "$lin_user\n";
        close (FILELDAPLOG);
        $| = 1;
        $temp = &tempname();
        open(TEMP, ">$temp");
        print TEMP "#!/bin/sh\n";
        print TEMP $env;
        print TEMP "export $export\n" if ($export);
        print TEMP "$str\n";
        $ens_obj = "--name \"".$config{tta_base}."/$ens_ou/cn=$username\"";
        $temp_f=$config{'tta_defaults_obj'}; 
        foreach $i (&load_ttaobj()) {
            if ( $i->{'property'} eq "user" ) { $user=$i->{'value'} };
            if ( $i->{'property'} eq "ntdomain" ) { $ntdomain=$i->{'value'} };
            if ( $i->{'property'} eq "bandwidth" ) { $bandwidth=$i->{'value'} };
            if ( $i->{'property'} eq "cdm" ) { $cdm=$i->{'value'} };
            if ( $i->{'property'} eq "enabled" ) { $enabled=$i->{'value'} };
            if ( $i->{'property'} eq "inherit" ) { $inherit=$i->{'value'} };
            if ( $i->{'property'} eq "shared" ) { $shared=$i->{'value'} };
            if ( $i->{'property'} eq "webtop" ) { $webtop=$i->{'value'} };
            if ( $i->{'property'} eq "conntype" ) { $conntype=$i->{'value'} };
        }
        $temp_f = &tempname();
        open(TEMPF, ">$temp_f");
                print TEMPF "$ens_obj\\\n";
                print TEMPF "  --surname \"$in{username}\" \\\n";
                if ( $user ne "" ) {print TEMPF "  --user \"$user\" \\\n"; }
                if ( $ntdomain ne "" ) {print TEMPF "  --ntdomain \"$ntdomain\"\\\n"; }
                if ( $bandwidth ne "" ) {print TEMPF "  --bandwidth \"$bandwidth\"\\\n"; }
                if ( $cdm ne "" ) {print TEMPF "  --cdm \"$cdm\"\\\n"; }
                if ( $enabled ne "" ) {print TEMPF "  --enabled \"$enabled\"\\\n"; }
                if ( $shared ne "" ) {print TEMPF "  --shared \"$shared\"\\\n"; }
                if ( $inherit ne "" ) {print TEMPF "  --inherit \"$inherit\"\\\n"; }
                if ( $conntype ne "" ) { print TEMPF "  --conntype \"$conntype\"\\\n"; }
                if ( $webtop ne "" ) {print TEMPF "  --webtop \"$webtop\"\\\n"; }
                print TEMPF "  --description \"$in{username}\" \n";
        close(TEMPF);

        if (&run_tta_cmd($type_cmd,$ens_obj,$temp_f)) { 
           print "<tr><p><b>".$text{'user_made'}.$username." ->  ".$in{userou}."</b></tr>\n";
           print "<tr></tr>\n";
           print "<tr><form METHOD=POST name=addusr ACTION=\"tta_modusr.cgi?username=$username&userou=$userou\" >\n"; 
           print "  <input TYPE=\"hidden\" NAME=\"postform\" VALUE=\"addusr\"\n";
           print "  <input TYPE=\"hidden\" NAME=\"username\" VALUE=\"",$username,"\"\n";
           print "  <input TYPE=\"hidden\" NAME=\"userou\" VALUE=\"",$userou,"\">\n";
           print "  <input TYPE=\"hidden\" NAME=\"administrador\" VALUE=\"",$administrador,"\">\n";
           print "  <input TYPE=\"hidden\" NAME=\"dn\" VALUE=\"",$dn,"\">\n";
           print "  <input TYPE=\"hidden\" NAME=\"passwdcache\" VALUE=\"",$passwdcache,"\">\n";
           print "        <tr><td valign=top><input TYPE=\"submit\" NAME=\"",$text{'f_modatt'},"\" VALUE=\"",$text{'f_modatt'},"\">\n";
           print "        &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;\n";
           print "	</form>\n"; 
        }
    }
 }
 print "<tr><tr></table></table><hr><p>\n";
 &footer($config{'back_return'},$text{'index'});
 print "<p><p><p>\n";
 do "footer.pl";
 exit;

